<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_InternalSupplier1 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_InternalSupplier1 extends AbstractStructArrayBase
{
    /**
     * The InternalTransferSupplier
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_InternalSupplier[]
     */
    public $InternalTransferSupplier;
    /**
     * Constructor method for ArrayOfJP_InternalSupplier1
     * @uses ArrayOfJP_InternalSupplier1::setInternalTransferSupplier()
     * @param \StructType\JP_InternalSupplier[] $internalTransferSupplier
     */
    public function __construct(array $internalTransferSupplier = array())
    {
        $this
            ->setInternalTransferSupplier($internalTransferSupplier);
    }
    /**
     * Get InternalTransferSupplier value
     * @return \StructType\JP_InternalSupplier[]|null
     */
    public function getInternalTransferSupplier()
    {
        return $this->InternalTransferSupplier;
    }
    /**
     * This method is responsible for validating the values passed to the setInternalTransferSupplier method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInternalTransferSupplier method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInternalTransferSupplierForArrayConstraintsFromSetInternalTransferSupplier(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_InternalSupplier1InternalTransferSupplierItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_InternalSupplier1InternalTransferSupplierItem instanceof \StructType\JP_InternalSupplier) {
                $invalidValues[] = is_object($arrayOfJP_InternalSupplier1InternalTransferSupplierItem) ? get_class($arrayOfJP_InternalSupplier1InternalTransferSupplierItem) : sprintf('%s(%s)', gettype($arrayOfJP_InternalSupplier1InternalTransferSupplierItem), var_export($arrayOfJP_InternalSupplier1InternalTransferSupplierItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InternalTransferSupplier property can only contain items of type \StructType\JP_InternalSupplier, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InternalTransferSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_InternalSupplier[] $internalTransferSupplier
     * @return \ArrayType\ArrayOfJP_InternalSupplier1
     */
    public function setInternalTransferSupplier(array $internalTransferSupplier = array())
    {
        // validation for constraint: array
        if ('' !== ($internalTransferSupplierArrayErrorMessage = self::validateInternalTransferSupplierForArrayConstraintsFromSetInternalTransferSupplier($internalTransferSupplier))) {
            throw new \InvalidArgumentException($internalTransferSupplierArrayErrorMessage, __LINE__);
        }
        $this->InternalTransferSupplier = $internalTransferSupplier;
        return $this;
    }
    /**
     * Add item to InternalTransferSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_InternalSupplier $item
     * @return \ArrayType\ArrayOfJP_InternalSupplier1
     */
    public function addToInternalTransferSupplier(\StructType\JP_InternalSupplier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_InternalSupplier) {
            throw new \InvalidArgumentException(sprintf('The InternalTransferSupplier property can only contain items of type \StructType\JP_InternalSupplier, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InternalTransferSupplier[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_InternalSupplier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_InternalSupplier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_InternalSupplier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_InternalSupplier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_InternalSupplier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InternalTransferSupplier
     */
    public function getAttributeName()
    {
        return 'InternalTransferSupplier';
    }
}
